// $Id: PhotonBuf.h,v 1.1.1.1 2006/02/21 18:48:00 hoshina Exp $
#ifndef __PhotonBuf__H__
#define __PhotonBuf__H__

//*************************************************************************
//* ---------------------
//* PhotonBuf Class
//* ---------------------
//* (Description)
//*     Buffer class for photons.
//* (Requires)
//* (Provides)
//*	PhotonBuf              : base class for datum
//* (Update Record)
//*	2003/12/15  K.Hoshina	Original version.
//*************************************************************************

#include "romeo/kern/RMOVBuffer.h"

class PhotonBuf : public RMOVBuffer
{

public:

  PhotonBuf(const TString &name="PhotonBuf")
           : RMOVBuffer(name, name) {}
  virtual ~PhotonBuf(){}

  virtual void            DumpInfo(Option_t *opt) {}

  inline virtual void     SetDistance(Double_t d)    { fDistance = d; }
  inline virtual Double_t GetDistance() const        { return fDistance; }
  inline virtual TObjArray& GetBuffer() { return *GetArrayPtr(); }
   
private:

  Double_t fDistance;        // direct distance between photon injection
                             // point and arrival point
 
  ClassDef(PhotonBuf, 1)     // Buffer class for photons

};

#endif

