// $Id: RayTracePhoton.h,v 1.2 2006/02/22 01:47:29 hoshina Exp $
#ifndef __RayTracePhoton__H__
#define __RayTracePhoton__H__

//*************************************************************************
//* ---------------------
//* RayTracePhoton Class
//* ---------------------
//* (Description)
//*     Photon class for raytrace which stores history of trajectory
//* (Requires)
//*     RMOOpticalPhoton
//* (Provides)
//*	RayTracePhoton              
//* (Update Record)
//*	2006/1/15  K.Hoshina	Original version.
//*************************************************************************

#include "romeo/kern/RMOOpticalPhoton.h"

using namespace std;

//class RayTracePhoton : public RMOOpticalPhoton, public RMOVAttBuffer {
//class RayTracePhoton : public RMOVAttBuffer, public RMOOpticalPhoton {
class RayTracePhoton : public RMOOpticalPhoton {

public:
 
  RayTracePhoton();
  RayTracePhoton(const TVector3 &pos,
                 const TVector3 &dir);

  virtual ~RayTracePhoton() {}
  virtual void DumpInfo(const Option_t* = "");

  static  void           ClearUniqueID()       { fID = 0; }
  static  TString        GetParticleName()     { return kParticleName; }
  inline virtual TString GetUniqueName() const { return fUniqueName; }

  inline virtual  void   SetHistory(const TObjArray &a) 
                          { fHistory.Delete(); fHistory.AddAll(&a); }

  inline virtual const TObjArray& GetHistory() const { return fHistory; }

private:

  static const TString  kParticleName;    // particle name = "OpticalPhoton"
  static UInt_t fID;                      // unique id for the photon
  TString       fUniqueName;              // unique name of the particle
  TObjArray     fHistory;                 // array of scattering history

  ClassDef(RayTracePhoton, 1)     // photon class for raytrace

};

#endif
