// $Id: RMOVAttBuffer.h,v 1.1.1.1 2005/06/23 11:43:50 hoshina Exp $
#ifndef __RMOVAttBuffer__H__
#define __RMOVAttBuffer__H__

//*************************************************************************
//* ---------------------
//* RMOVAttBuffer Class
//* ---------------------
//* (Description)
//*     Abstract attribute class for data buffer
//* (Requires)
//* (Provides)
//*	RMOVAttBuffer              : base class for buffer
//* (Update Record)
//*	2003/12/15  K.Hoshina	Original version.
//*************************************************************************

#include "TObjArray.h"

class RMOVAttBuffer {

public:

  RMOVAttBuffer();
  virtual ~RMOVAttBuffer();

  virtual void     Add(TObject *obj)               { fArray.Add(obj); }
  virtual void     DumpInfo(Option_t *opt="") = 0;
  virtual TObject* First() const                   { return fArray.First(); } 
  virtual TObject* Last() const                    { return fArray.Last(); } 
  virtual Int_t    GetEntries() const              { return fArray.GetEntries(); }
  virtual TIter    GetIter(Bool_t direction = kIterForward) const;
  virtual Bool_t   IsOwner() const                 { return fArray.IsOwner(); }
  virtual void     SetOwner(Bool_t enable = kTRUE) { fArray.SetOwner(enable); }
  virtual void     Sort(Int_t upto = kMaxInt)      { fArray.Sort(upto); }
  virtual void     UnSort()                        { fArray.UnSort(); }
  virtual void     Clear(Option_t *opt="")         { fArray.Clear(opt); }
  virtual void     Delete(Option_t *opt="")        { fArray.Delete(opt); }


protected:
  virtual TObjArray * GetArrayPtr()      { return &fArray; }

private:

  TObjArray   fArray;              // data buffer array

  ClassDef(RMOVAttBuffer, 1)       // abstract base class for datum 

};

#endif

