// $Id: RMOVAttDatum.h,v 1.1.1.1 2005/06/23 11:43:50 hoshina Exp $
#ifndef __RMOVAttDatum__H__
#define __RMOVAttDatum__H__

//*************************************************************************
//* ---------------------
//* RMOVAttDatum Class
//* ---------------------
//* (Description)
//*     Abstract attribute class for datum.
//* (Requires)
//* (Provides)
//*	RMOVAttDatum              : base class for datum
//* (Update Record)
//*	2003/12/15  K.Hoshina	Original version.
//*************************************************************************

#include "Rtypes.h"

class RMOVAttDatum {

public:

  RMOVAttDatum() : fMotherPtr(0), fValidity(kTRUE) {}
  virtual ~RMOVAttDatum(){}

  virtual void              DumpInfo(Option_t *opt) = 0;
  inline virtual TObject*   GetMother() const     { return fMotherPtr; }
  inline virtual void       SetMother(TObject *m) { fMotherPtr = m; }
  inline virtual void       SetValidity(Bool_t f=kTRUE) { fValidity = f; }
  inline virtual Bool_t     IsValid()                { return fValidity; }

private:

  TObject *fMotherPtr;              // Pointer to mother datum
  Bool_t   fValidity;               // valid flag

  ClassDef(RMOVAttDatum, 1)            // abstract base class for datum 
};

#endif

