// $Id: RMOVParticle.h,v 1.2 2005/11/13 00:08:41 syoshida Exp $
#ifndef __RMOVParticle__H__
#define __RMOVParticle__H__

//*************************************************************************
//* ---------------------
//* RMOVParticle Class
//* ---------------------
//* (Description)
//*     Abstract base class for particles.
//* (Requires)
//* (Provides)
//*	RMOVParticle              : base class of particles 
//* (Update Record)
//*	2003/12/15  K.Hoshina	Original version.
//*************************************************************************


#include "romeo/kern/RMOPoint.h"

class RMOVParticle : public RMOPoint {

public:

  RMOVParticle();
  RMOVParticle(const TVector3 &pos,
               const TVector3 &dir);

  virtual ~RMOVParticle();

  virtual  TVector3  GetPolarization() const       { return fPolarization; }
  virtual  Double_t  GetEnergy()       const       { return fEnergy;       }
  virtual  Int_t     GetWeight()       const       { return fWeight;       }
  virtual  void      SetPolarization(TVector3 pol) { fPolarization = pol;  }
  virtual  void      SetEnergy(Double_t ene)       { fEnergy = ene;        }
  virtual  void      SetWeight(Int_t w)            { fWeight = w;          }
  virtual  void      Output(ofstream &out);

private:

  Double_t  fEnergy;               // particle energy
  Int_t     fWeight;               // Weight of this particle
  TVector3  fPolarization;         // polarization of the particle

  ClassDef(RMOVParticle, 1)        // abstract base class for particles

};

#endif

