// @(#)root/hist:$Name:  $:$Id: TH1DEX.h,v 1.1.1.1 2006/02/21 18:48:00 hoshina Exp $
// Author: Rene Brun   18/05/2002

/*************************************************************************
 * Copyright (C) 1995-2000, Rene Brun and Fons Rademakers.               *
 * All rights reserved.                                                  *
 *                                                                       *
 * For the licensing terms see $ROOTSYS/LICENSE.                         *
 * For the list of contributors see $ROOTSYS/README/CREDITS.             *
 *************************************************************************/

#ifndef ROOT_TH1DEX
#define ROOT_TH1DEX


//////////////////////////////////////////////////////////////////////////
//                                                                      //
// TH1DEX                                                               //
//                                                                      //
// 1-Dim histogram with a double per channel                            //
// Created to make BufferFill function public                           //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include "TH1D.h"

class TH1DEX : public TH1D {

public:

    TH1DEX() : TH1D() {}
    TH1DEX(const char *name,const char *title,Int_t nbinsx,Axis_t xlow,Axis_t xup):
               TH1D(name, title, nbinsx, xlow, xup) {}
    TH1DEX(const char *name,const char *title,Int_t nbinsx,const Float_t *xbins):
               TH1D(name, title, nbinsx, xbins) {}
    TH1DEX(const char *name,const char *title,Int_t nbinsx,const Double_t *xbins):
               TH1D(name, title, nbinsx, xbins) {}
    TH1DEX(const TVectorD &v) : TH1D(v) {}
    TH1DEX(const TH1D& orig) : TH1D(orig) {}

    virtual ~TH1DEX() {}

    virtual Int_t  BufferFill(Axis_t x, Stat_t w) { return TH1D::BufferFill(x, w); }

    ClassDef(TH1DEX,1)  //1-Dim histograms (one double per channel)

};
 

#endif
