//
// global constants
//
const Int_t    kNTimeBins       = 500;
const Int_t    kNZenithAngBins  = 18;
const Int_t    kNAzimuthAngBins = 36;
const Int_t    kNCosThetaBins = 2001; // corresponds 5.5m vertical length after 125m propagation
const Double_t kCosThetaBinSize = (2.0 / kNCosThetaBins); 
const Double_t kCosThetaBinEdge = (1.0 - kCosThetaBinSize);
const Double_t kPi = TMath::Pi();
const Double_t kRadToDeg = (180. / kPi);


// Test program for TH1DEX class
Int_t TH1DEXTest()
{
   gSystem->Load("libPhysics.so");
   gSystem->Load("libPhysics.so");
   gSystem->Load("../../lib/libutils.so");
   gStyle->SetOptStat("ne");

   // fill gaussian at specific bin

   Double_t time;
   Double_t meantime = 500.; // ns
   Double_t sigmatime = 3.;  // ns

   Int_t nfills = 1000;

   TH1DEX *exdim = new TH1DEX("exdim", "exdim", kNTimeBins, 0., 1500);
   for (Int_t i=0; i<nfills; i++) {
      time = gRandom->Gaus(meantime, sigmatime);
      exdim->Fill(time);
   }      
   exdim->Draw();

}


