#! /usr/bin/python

#----------------------------------------------------
# Calculate opening angle of DOMs from flasher
#
# 17/Feb/2006 K.Hoshina My first python script! :)
#----------------------------------------------------

import math

class DomPosition:

	# data members

	fID = 0    # ID of dom 
	fX  = 0    # horisontal distance
	fZ  = 0    # vertical distance
	fDist = 0  # distance between flasher and target dom
	fRad = 0   # opening angle [rad]
	fDeg = 0   # opening angle [deg]
	fCostheta = 0 # opening angle [costheta]

	def __init__(self):
		self.fID = 0
		self.fX = 0
		self.fZ = 0
		self.fDist = 0
		self.fRad = 0
		self.fDeg = 0
		self.fCostheta = 0

	def setIDandXZ(self, id, x, z):
		self.fID = id
		self.fX = x
		self.fZ = z
		self.fDist = math.sqrt(self.fX*self.fX + self.fZ*self.fZ)
		self.fCostheta = self.fX / self.fDist
		self.fRad = math.acos(self.fCostheta)
		self.fDeg = self.fRad / math.pi * 180.0

	def printData(self):
		print self.fID, self.fX, self.fZ, self.fDist, self.fRad, self.fDeg, self.fCostheta
			
# end of class DomPosition

#dist = 125
dist = 250
spacing = 17
ndoms = 10

print """
DOMID   x      z      Distance   Ang[rad]   Ang[deg]   CosTheta
---------------------------------------------------------------
"""

for i in range(ndoms):
	curdom = DomPosition()
	curdom.setIDandXZ(i, dist, i*17)
	curdom.printData()



